from . import swift
from . import local

from .abc import Downloader, Uploader


def get_downloader(type_name, args, kwargs) -> Downloader:
    if type_name == 'swift':
        return swift.Downloader(*args or [], **kwargs or {})
    elif type_name == 'local':
        return local.Downloader(*args or [], **kwargs or {})

    raise Exception('Downloader type %s is not supported' % type_name)


def get_uploader(type_name, args, kwargs) -> Uploader:
    if type_name == 'swift':
        return swift.Uploader(*args or [], **kwargs or {})
    elif type_name == 'local':
        return local.Uploader(*args or [], **kwargs or {})

    raise Exception('Uploader type %s is not supported' % type_name)
